diff --git a/include/view.h b/include/view.h
index f5deac96a..5268f7d8b 100644
--- a/include/view.h
+++ b/include/view.h
@@ -193,6 +193,7 @@ RofiViewState * rofi_view_get_active ( void );
  *
  */
 void rofi_view_set_active ( RofiViewState *state );
+void rofi_view_remove_active ( RofiViewState *state );
 
 /**
  * @param msg The error message to show.
diff --git a/source/dialogs/drun.c b/source/dialogs/drun.c
index aac7a934a..94200cbc0 100644
--- a/source/dialogs/drun.c
+++ b/source/dialogs/drun.c
@@ -1041,7 +1041,12 @@ static ModeMode drun_mode_result ( Mode *sw, int mretv, char **input, unsigned i
         }
     }
     else if ( ( mretv & MENU_CUSTOM_INPUT ) && *input != NULL && *input[0] != '\0' ) {
-        retv = RELOAD_DIALOG;
+        RofiHelperExecuteContext context = { .name = NULL };
+        gboolean             run_in_term = ( ( mretv & MENU_CUSTOM_ACTION ) == MENU_CUSTOM_ACTION );
+        // FIXME: We assume startup notification in terminals, not in others
+        if ( ! helper_execute_command ( NULL, *input, run_in_term, run_in_term ? &context : NULL ) ) {
+            retv = RELOAD_DIALOG;
+        }
     }
     else if ( ( mretv & MENU_ENTRY_DELETE ) && selected_line < rmpd->cmd_list_length ) {
         // Possitive sort index means it is in history.
diff --git a/source/dialogs/run.c b/source/dialogs/run.c
index 0d2230522..5e0c064ac 100644
--- a/source/dialogs/run.c
+++ b/source/dialogs/run.c
@@ -78,18 +78,18 @@ typedef struct
  *
  * Execute command and add to history.
  */
-static void exec_cmd ( const char *cmd, int run_in_term )
+static gboolean exec_cmd ( const char *cmd, int run_in_term )
 {
     GError *error = NULL;
     if ( !cmd || !cmd[0] ) {
-        return;
+        return FALSE;
     }
     gsize lf_cmd_size = 0;
     gchar *lf_cmd     = g_locale_from_utf8 ( cmd, -1, NULL, &lf_cmd_size, &error );
     if ( error != NULL ) {
         g_warning ( "Failed to convert command to locale encoding: %s", error->message );
         g_error_free ( error );
-        return;
+        return FALSE;
     }
 
     char                     *path   = g_build_filename ( cache_dir, RUN_CACHE_FILE, NULL );
@@ -102,12 +102,16 @@ static void exec_cmd ( const char *cmd, int run_in_term )
          */
 
         history_set ( path, cmd );
+        g_free ( path );
+        g_free ( lf_cmd );
+        return TRUE;
     }
     else {
         history_remove ( path, cmd );
+        g_free ( path );
+        g_free ( lf_cmd );
+        return FALSE;
     }
-    g_free ( path );
-    g_free ( lf_cmd );
 }
 
 /**
@@ -371,10 +375,14 @@ static ModeMode run_mode_result ( Mode *sw, int mretv, char **input, unsigned in
     gboolean           run_in_term = ( ( mretv & MENU_CUSTOM_ACTION ) == MENU_CUSTOM_ACTION );
 
     if ( ( mretv & MENU_OK ) && rmpd->cmd_list[selected_line] != NULL ) {
-        exec_cmd ( rmpd->cmd_list[selected_line], run_in_term );
+        if ( !exec_cmd ( rmpd->cmd_list[selected_line], run_in_term ) ) {
+          retv = RELOAD_DIALOG;
+        }
     }
     else if ( ( mretv & MENU_CUSTOM_INPUT ) && *input != NULL && *input[0] != '\0' ) {
-        exec_cmd ( *input, run_in_term );
+        if ( !exec_cmd ( *input, run_in_term ) ) {
+          retv = RELOAD_DIALOG;
+        }
     }
     else if ( ( mretv & MENU_ENTRY_DELETE ) && rmpd->cmd_list[selected_line] ) {
         delete_entry ( rmpd->cmd_list[selected_line] );
diff --git a/source/rofi.c b/source/rofi.c
index 314ea0972..6eaa5b06a 100644
--- a/source/rofi.c
+++ b/source/rofi.c
@@ -208,7 +208,7 @@ static void run_switcher ( ModeMode mode )
 void process_result ( RofiViewState *state )
 {
     Mode *sw = state->sw;
-    rofi_view_set_active ( NULL );
+ //   rofi_view_set_active ( NULL );
     if ( sw != NULL ) {
         unsigned int selected_line = rofi_view_get_selected_line ( state );;
         MenuReturn   mretv         = rofi_view_get_return_value ( state );
@@ -246,11 +246,17 @@ void process_result ( RofiViewState *state )
              * Load in the new mode.
              */
             rofi_view_switch_mode ( state, modi[mode] );
-            rofi_view_set_active ( state );
             curr_switcher = mode;
             return;
+        } else {
+          // On exit, free current view, and pop to one above.
+          rofi_view_remove_active ( state );
+          rofi_view_free ( state );
+          return;
         }
     }
+//    rofi_view_set_active ( NULL );
+          rofi_view_remove_active ( state );
     rofi_view_free ( state );
 }
 
diff --git a/source/view.c b/source/view.c
index 44ce93285..5ba1309a7 100644
--- a/source/view.c
+++ b/source/view.c
@@ -415,6 +415,9 @@ static void rofi_view_calculate_window_position ( RofiViewState *state )
 
 static void rofi_view_window_update_size ( RofiViewState * state )
 {
+    if ( state == NULL ) {
+      return;
+    }
     uint16_t mask   = XCB_CONFIG_WINDOW_X | XCB_CONFIG_WINDOW_Y | XCB_CONFIG_WINDOW_WIDTH | XCB_CONFIG_WINDOW_HEIGHT;
     uint32_t vals[] = { state->x, state->y, state->width, state->height };
 
@@ -490,6 +493,15 @@ RofiViewState * rofi_view_get_active ( void )
     return current_active_menu;
 }
 
+void rofi_view_remove_active ( RofiViewState *state )
+{
+  if ( state == current_active_menu ) {
+    rofi_view_set_active ( NULL );
+  }
+  else if ( state ) {
+    g_queue_remove ( &(CacheState.views ), state);
+  }
+}
 void rofi_view_set_active ( RofiViewState *state )
 {
     if ( current_active_menu != NULL && state != NULL ) {
